{ pkgs ? import <nixpkgs> { }
, callPackage ? pkgs.callPackage
, stdenv ? pkgs.stdenv
, fetchgit ? pkgs.fetchgit
, name ? "brownpaper"
, src ? (builtins.filterSource (path: type: baseNameOf path != "target") ./.)
}:
let
  crate2nix_tools = import "${fetchgit { url = "https://github.com/kolloch/crate2nix.git"; rev = "adecff03c53b87255b3299f5a5787327342a69b2"; sha256 = "0l10yqa3gq73fc4xc977vb9zk5jlp70xiz5qd9c1vq873yqk1c7g"; }}/tools.nix" { inherit pkgs; };
  overrides = pkgs.defaultCrateOverrides // rec {
    nettle-sys = attrs: with pkgs; {
      nativeBuildInputs = [ clang nettle pkg-config ];
      LIBCLANG_PATH = "${clang.cc.lib}/lib";
    };
    sequoia-openpgp = attrs: with pkgs; {
      nativeBuildInputs = [ clang gmp pkg-config ];
      LIBCLANG_PATH = "${clang.cc.lib}/lib";
    };
    brownpaper = sequoia-openpgp; # requires gmp as well
  };
  client = pkgs.writeShellScriptBin "brownpaper" ''
    PATH=${pkgs.bash}/bin/:${pkgs.gnupg}/bin/:${pkgs.curl}/bin/:$PATH ${./bp.sh} "$@"
  '';
in
{ server = (crate2nix_tools.generatedCargoNix { inherit name src; });  inherit client; }
